// Author: gre
// License: MIT

uniform float colorSeparation; // = 0.04

vec4 transition (vec2 uv) {
  float x = 0.5 + (uv.x-0.5) / (1.0-progress);
  if (x < 0.0 || x > 1.0) {
    return getToColor(uv);
  }
  else {
    vec2 fp = vec2(x, uv.y);
    vec2 off = progress * vec2(0.0, colorSeparation);
    vec4 c = getFromColor(fp);
    vec4 cn = getFromColor(fp - off);
    vec4 cp = getFromColor(fp + off);
    return vec4(cn.r, c.g, cp.b, c.a);
  }
}